<?php
/**
 * FuzeWorks Forms Library
 *
 * The FuzeWorks PHP FrameWork
 *
 * Copyright (C) 2013-${YEAR} i15
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * @author    i15
 * @copyright Copyright (c) 2013 - ${YEAR}, i15. (http://i15.nl)
 * @license   https://opensource.org/licenses/MIT MIT License
 *
 * @link  https://i15.nl
 * @since Version 1.3.0
 *
 * @version Version 1.3.0
 */

namespace FuzeWorks\Forms\Fields;

class SelectField extends RadioField
{

    protected int $size = 0;

    /**
     * Set the number of visible options of the drop-down list.
     *
     * @param int $size
     * @return $this
     */
    public function size(int $size): SelectField
    {
        $this->size = $size;
        return $this;
    }

    public function generateHtml(): string
    {
        $id = "id='".$this->getId()."'";
        $name = "name='".$this->getName()."'";
        $label = $this->getLabel();
        $lock = $this->lock ? "disabled" : "";
        $class = "class='".implode(" ", $this->classNames)."'";
        $required = !$this->optional ? "required" : "";
        $size = $this->size == 0 ? "" : "size='".$this->size."'";

        $out = "<div $class>";
        $out .= "<label for='$name'>$label</label>";
        $out .= "<select class='form-control' $name $id $lock $required $size>";
        foreach ($this->options as $key => $val)
        {
            $selected = $key === $this->value ? "selected" : "";
            $out .= "<option value='$key' $selected>" . $val . "</option>";
        }

        $out .= "</select></div>";
        return $out;
    }

}